Attribute VB_Name = "modRemotMenue"
' Dieser Source stammt von http://www.activevb.de
' und kann frei verwendet werden. Fr eventuelle Schden
' wird nicht gehaftet.

' Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
' Ansonsten viel Spa und Erfolg mit diesem Source !

' Autor: K. Langbein Klaus@ActiveVB.de
' berarbeitet und Kommentiert von Thomas Rodemer (Thomas@ActiveVB.de)

' Die API bietet die Mglichkeit fremde Mens auszulesen und die
' entsprechenden Handles und Identifier zu ermitteln. Wenn man diese
' erstmal hat kann man ganz diese Mens auch ganz einfach fernsteuern.
' Leider werden Mens, die Grafiken enthalten nicht erkannt. Wei
' jemand Rat?

Option Explicit
Type Menu_Descriptor

    text As String
    Key As String
    Type As Long
    nSub As Long
    Id As Long
    ParenthMenu As Long
    ParentHwnd As Long
    level As Long
    pos As Long
    
End Type

Public Type WindowDescr

    hWnd As Long
    prid As Long
    Title As String
    Class As String
    ExeName As String
End Type


Public MenuList() As Menu_Descriptor

Public Const WM_CLOSE = &H10
Public Const WM_COMMAND = &H111
Public Const WM_SYSCOMMAND = &H112
Public Const WM_DESTROY = &H2

Declare Function BringWindowToTop Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function GetClassName Lib "user32" _
                 Alias "GetClassNameA" ( _
                 ByVal hWnd As Long, _
                 ByVal lpClassName As String, _
                 ByVal nMaxCount As Long) As Long
                 
Declare Function GetForegroundWindow Lib "user32" () As Long

Declare Function ShowWindow Lib "user32" ( _
                 ByVal hWnd As Long, _
                 ByVal nCmdShow As Long) As Long
                 
Declare Function GetWindowText Lib "user32" _
                 Alias "GetWindowTextA" ( _
                 ByVal hWnd As Long, _
                 ByVal lpstring As String, _
                 ByVal cch As Long) As Long
                 
Declare Function SendMessageByNum Lib "user32" _
                 Alias "SendMessageA" ( _
                 ByVal hWnd As Long, _
                 ByVal wMsg As Long, _
                 ByVal wparam As Long, _
                 lparam As Long) As Long
                 
Declare Function FindWindow Lib "user32" _
                 Alias "FindWindowA" ( _
                 ByVal lpClassName As String, _
                 ByVal lpWindowName As String) As Long
                 
Declare Function GetDeskTopWindow Lib "user32" _
                 Alias "GetDesktopWindow" () As Long
                 
Declare Function IsWindow Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function IsWindowVisible Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function GetWindowThreadProcessId Lib "user32" ( _
                 ByVal hWnd As Long, _
                 lpdwProcessId As Long) As Long
                 
Declare Function GetParent Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function GetTopWindow Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function GetWindow Lib "user32" ( _
                 ByVal hWnd As Long, _
                 ByVal wCmd As Long) As Long
                 
Declare Function GetWindowModuleFileName Lib "user32" _
                 Alias "GetWindowModuleFileNameA" ( _
                 ByVal hWnd As Long, _
                 ByVal pszFileName As String, _
                 ByVal cchFileNameMax As Long) As Long
                 
Declare Function GetMenuItemCount Lib "user32" ( _
                 ByVal hmenu As Long) As Long
                 
Declare Function GetMenuItemID Lib "user32" ( _
                 ByVal hmenu As Long, _
                 ByVal nPos As Long) As Long
                 
Declare Function GetMenuString Lib "user32" _
                 Alias "GetMenuStringA" ( _
                 ByVal hmenu As Long, _
                 ByVal wIDItem As Long, _
                 ByVal lpstring As String, _
                 ByVal nMaxCount As Long, _
                 ByVal wFlag As Long) As Long
                 
Declare Function GetSubMenu Lib "user32" ( _
                 ByVal hmenu As Long, _
                 ByVal nPos As Long) As Long
                 
Declare Function GetMenu Lib "user32" ( _
                 ByVal hWnd As Long) As Long
                 
Declare Function GetMenuState Lib "user32" ( _
                 ByVal hmenu As Long, _
                 ByVal wID As Long, _
                 ByVal wFlags As Long) As Long
                 
Declare Function GetSystemMenu Lib "user32" ( _
                 ByVal hWnd As Long, _
                 ByVal bRevert As Long) As Long

Function FileTitle(ByVal fullname As String) As String
    Dim pos As Integer
    Dim i As Integer
    Dim l As Integer
    Dim t As String
    Dim tt As String
    
    l = Len(fullname)
    
    For i = l To 1 Step -1
        t = Mid$(fullname, i, 1)
        
        If t = "\" Then
            Exit For
        End If
    Next i
    
    If i > 0 Then
        t = Right$(fullname, l - i)
    Else
        t = fullname
    End If
    
    If Len(t) = 2 Then
        If Right$(t, 1) = ":" Then
            t = ""
        End If
    End If
    
    tt = Left$(t$, 1)
    If tt = "*" Or tt$ = "." Then
        t = ""
    End If
    
    FileTitle = t$
End Function

Sub Pause(ByVal pau As Single, ByVal doev As Integer)
    Dim t As Single
    t = Timer
    
    Do
        If doev = 1 Then
            DoEvents
        End If

    Loop Until (Timer - t) >= pau
End Sub

Function wintitle(ByVal handle As Long) As String
    ' Liest den Titel der Anwendung aus.
    Dim l As Long
    Dim buffer As String
    
    buffer = Space$(250)
    l = GetWindowText(handle, buffer, 250)
    wintitle = Left$(buffer, l)
End Function

Function winclass(ByVal handle As Long) As String
    ' Liest den Klassennamen aus.
    
    Dim l As Long
    Dim buffer As String
    buffer = Space$(250)
    
    l = GetClassName(handle, buffer, 250)
    winclass = Left$(buffer, l)
End Function
Function winExeName(ByVal handle As Long) As String

    ' Liest den vollstndigen Pfad und den Exe-Dateinamen aus.
    Dim l As Long
    Dim buffer As String
    buffer = Space(250)
    
    l = GetWindowModuleFileName(handle, buffer, 250)
    
    If l > 0 Then
        buffer = Left$(buffer, l)
        If Right$(buffer, 1) = Chr$(0) Then
            winExeName = Left$(buffer, Len(buffer) - 1)
        Else
            winExeName = buffer
        End If
    End If
End Function
Function Msg_MenuClick(ByVal hand As Long, ByVal Id As Long) As Long
    
    ' Simuliert einen Klick auf den entsprechend vorher ausgewhlten
    ' Meneintrag.
    
    Dim ret As Long
    Const WM_COMMAND = &H111
    
    ret = SendMessageByNum(hand, WM_COMMAND, Id, 0&)

    Msg_MenuClick = ret
End Function
Function Msg_SysMenuClick(ByVal hand As Long, ByVal Id As Long) As Long
    
    ' Simuliert einen Klick auf den entsprechend vorher ausgewhlten
    ' Systemmeneintrag.

    Dim ret As Long
    Const WM_SYSCOMMAND = &H112
    
    ret = SendMessageByNum(hand, WM_SYSCOMMAND, Id, 0&)

    Msg_SysMenuClick = ret
End Function

Sub List_Menu(ByVal hWnd, ByVal hmenu As Long, sys As Long)

    ' Erstellt die Liste der Meneintrge. Beachte:
    ' Die Funktion wird rekursiv verwendet, d.h. sie
    ' ruft sich selbst auf.
    
    Dim menuID As Long
    Dim menuFlag As Long
    Dim menuCnt As Long
    Dim i As Long
    Dim ret As Long
    Dim pos As Long
    Dim MenuText As String
    Dim mText As String
    Static level As Long
    Static cnt As Long
    Dim ub As Long
    Dim subMenu As Long
    Const MF_BYPOSITION = 1024
    Const MF_BYCOMMAND = 0
    
    If hmenu = 0 Then
        If sys = True Then
            hmenu = GetSystemMenu(hWnd, 0)
        Else
            hmenu = GetMenu(hWnd)
        End If
        cnt = 0
        level = 0
        MenuList(0).ParenthMenu = hmenu
    End If
    
    If hmenu <= 0 Then  ' Wenn nicht verfgbar > abbrechen
        Exit Sub
    End If
    
    menuCnt = GetMenuItemCount(hmenu)
    If menuCnt < 0 Then
        MsgBox "Error"
        Exit Sub
    End If
    
    ub = UBound(MenuList)
    ReDim Preserve MenuList(ub + menuCnt)
    level = level + 1
    
    MenuText = String$(256, 0)
  
    For i = 0 To menuCnt - 1
        ' ID fr diese Men lesen
        '  -1 fr Popup, 0 fr Seperator
        menuID = GetMenuItemID(hmenu, i)
        
        MenuText = String$(256, 0)
        Select Case menuID
            Case 0  ' Seperator
                cnt = cnt + 1
                MenuList(cnt).Type = 0
                mText$ = "---------------"
            Case -1 ' Popup menu
                cnt = cnt + 1
                MenuList(cnt).Type = 1
                ret = GetMenuString(hmenu, i, MenuText, 127, MF_BYPOSITION)
                menuFlag = GetMenuState(hmenu, i, MF_BYPOSITION)
                
            Case Else ' Normaler Eintrag
                cnt = cnt + 1
                ret = GetMenuString(hmenu, menuID, MenuText, 127, MF_BYCOMMAND)
                menuFlag = GetMenuState(hmenu, menuID, MF_BYCOMMAND)
                
                MenuList(cnt).Type = 2
          End Select
          
          If MenuList(cnt).Type > 0 Then
            pos = InStr(1, MenuText, Chr$(0), 1)
            mText = Left$(MenuText, pos - 1)
          End If
          MenuList(cnt).Id = menuID
          MenuList(cnt).ParentHwnd = hWnd
          MenuList(cnt).ParenthMenu = hmenu
          MenuList(cnt).text = mText
          MenuList(cnt).level = level
          MenuList(cnt).pos = i
                    
          If MenuList(cnt).Type = 1 Then
                subMenu = GetSubMenu(hmenu, i)
                menuCnt = GetMenuItemCount(subMenu)
                MenuList(cnt).nSub = menuCnt
                Call List_Menu(hWnd, subMenu, 0)
          End If
          
    Next i
    level = level - 1

End Sub

Function GetShellHwnd(ByVal ExeFile$, ByVal Wstyle As Long) As Variant

    ' Diese Funktion ruft ein Programm auf, liest dessen
    ' Fensterhandle aus und gibt es zurck.
    
    Dim wDescr() As WindowDescr
    Dim hh As Long
    Dim i As Long
    Dim prid As Long
    Dim cnt As Long
    Dim hWnd() As Long
    prid = Shell(ExeFile, Wstyle)
    Call Pause(0.1, 1)
       
    Call GetWindowList(wDescr())
    
    ReDim hWnd(0)
    For i = 1 To UBound(wDescr)
        
        If wDescr(i).prid = prid Then
            If wDescr(i).Class <> "tooltips_class" <> 0 Then
                hWnd(cnt) = wDescr(i).hWnd
                cnt = cnt + 1
                ReDim Preserve hWnd(cnt)
            End If
        End If
            
    Next i
    cnt = cnt - 1
    ReDim Preserve hWnd(cnt)
    GetShellHwnd = hWnd()
End Function

Sub GetWindowInfo(ByRef wDescr As WindowDescr)

    ' Liest Informationen des Zielfensters aus
    
    Dim buff As String
    Dim buff2 As String
    Dim buff3 As String
    Dim prid As Long
    Dim htask As Long
    Dim ub As Long
    Dim hParent As Long
    Dim PridA As Long
    
    prid = 0
    hParent = GetAncestor(wDescr.hWnd)
   
    PridA = GetWindowThreadProcessId(hParent, prid)
     
    wDescr.Title = wintitle(wDescr.hWnd)
    wDescr.Class = winclass(wDescr.hWnd)
    wDescr.ExeName = winExeName(wDescr.hWnd)
    wDescr.prid = prid
End Sub

Function GetWindowList(ByRef wDescr() As WindowDescr) As Long
    ' Diese Funktion sucht alle offenen Fenster.
    
    Dim i As Long
    Dim hh As Long
    
    hh = GetTopWindow(0&)
    ReDim wDescr(100)
    
    Do
        i = i + 1
        If i > UBound(wDescr) Then
            ReDim Preserve wDescr(UBound(wDescr) + 10)
        End If
        
        hh = GetWindow(hh, 2)
        If hh <> 0 Then
            wDescr(i).hWnd = hh
        End If
        Call GetWindowInfo(wDescr(i))
    Loop Until hh = 0
    
    ReDim Preserve wDescr(i)
    GetWindowList = i
End Function


Function GetAncestor(ByVal hWnd) As Long
    Dim hParent As Long
    Dim hw As Long
    hw = hWnd
    
    Do
        hParent = GetParent(hw)
        If hParent <> 0 Then
            hw = hParent
        End If
    Loop Until hParent = 0
    GetAncestor = hw
End Function
